<template lang="pug">
q-layout
  q-page-container
    q-page.text-center.overflow-hidden
      //- EMAIL LOGIN DIALOG (CHANGED FOR GIT)
      q-dialog(v-model="emailLogin")
        q-card(style="width: 800px; max-width: 90vm")
          q-card-section
            .text-h5.q-mb-md {{ $t('enter_your_email_to_receive_a_one-time_link') }}
            q-input.text-body1(
              ref="emailinput",
              filled,
              type="email",
              v-model="email",
              :label="$t('email')",
              reactive-rules,
              :rules="[(val) => isEmail(val) || $t('email_address_is_required')]"
            )
              template(v-slot:prepend)
                q-icon(:name="farEnvelope")

          q-separator
          q-card-actions(align="right")
            q-btn(
              :disable="isDisabled()",
              @click="sentEmail = true; signInWithEmail()",
              flat
            )
              q-icon(left, :name="farEnvelope")
              div {{ $t('send_me_an_email') }}
          q-inner-loading.bg-dark(:showing="sentEmail")
            .text-body1.q-mb-md.text-white.text-center(v-if="sentEmail")
              q-icon(:name="matMarkEmailRead", size="lg")
              div {{ $t('signinlink') }}

      q-dialog(v-model="mainLogin")
        q-card.text-center(style="width: 800px; max-width: 90vm")
          .text-h5.q-ma-md {{ $t('start_login') }}
          q-card-section(horizontal)
            q-card-section.q-pa-lg.col
              q-btn.liblue(stack, @click="signInWithLinkedIn()", size="md")
                q-icon(:name="fabLinkedinIn", size="lg")
                div {{ $t('sign_in_with_linkedin_to_submit') }}

            q-separator(vertical, inset)
            q-card-section.q-pa-lg.col
              q-btn(stack, flat, @click="mainLogin = false; emailLogin = true")
                q-icon(:name="farEnvelope", size="lg")
                div {{ $t('email_login') }}

      .row
        .col-md-6.col-12.q-px-md
          img.mainlogo.q-mt-xl(
            src="~@/assets/img/logo1.png",
            v-intersection="onIntersection"
          )

          .text-title.q-my-sm.text-secondary {{ $t('innovation_academy') }}

          .row.justify-center.q-my-lg
            .col-12.text-hero.text-secondary.text-bold.q-mb-md {{ $t('landing1') }}
            //- .col-12.text-hero.text-secondary {{ $t('landing2') }}

          .q-mb-xl.q-pa-lg
            //-   q-btn.q-ma-md(
            //-     size="lg",
            //-     unelevated,
            //-     outline,
            //-     rounded,
            //-     color="primary",
            //-     @click="goto('events')"
            //-   ) {{ $t('recording_btn') }}

            //- q-btn(size="lg", @click="goto('apply')", rounded, color="primary") {{ $t('faq.faq4.question') }}
            q-btn(
              size="lg",
              type="a",
              href="https://solferinoacademy.com",
              rounded,
              color="primary"
            ) {{ $t('innovation_academy') }}

        .col-md-6.col-12.self-end
          img.background1(
            src="~@/assets/img/header1.png",
            :class="{ background2: $q.screen.gt.sm }"
          )

      .shadow-12.z-top.bg-white
        //- .row.q-pt-xl.justify-center
          //- .col-10.text-h5.text-secondary.q-mb-md {{ $t('submission_end') }}
        //- .row.q-pt-sm.q-pb-sm.justify-center
        //-   q-btn(size="lg", @click="startLogin", rounded, color="primary") {{ $t('view_profile') }}
        //- KEY DATES
        //- .row.bg-grey-1.q-px-lg.q-pb-md.q-col-gutter-md.justify-center.items-stretch
        //-   .col-6.col-md-3.col-lg-2(
        //-     v-for="(k, index) in keydates",
        //-     :key="index"
        //-   )
        //-     q-responsive(:ratio="1")
        //-       q-card.overflow-hidden.full-height(
        //-         bordered,
        //-         flat,
        //-         style="border-radius: 20px"
        //-       )
        //-         .column.full-height
        //-           .col-auto
        //-             q-card-section.q-px-xs.q-py-sm.bg-primary
        //-               .fontsize-13.text-white.text-bold {{ k.dates[0] }} - {{ k.dates[1] }}
        //-           .col.q-pb-sm.q-px-sm
        //-             .column.justify-center.full-height
        //-               .col-auto
        //-                 .fontsize-17.text-secondary {{ k.subtitle }}
        //-                 .fontsize-17 {{ k.title }}

        //- .row.justify-center.q-pa-md
        //-   .col-12.col-md-8.col-lg-6.q-my-lg
        //-     q-video(
        //-       src="https://www.youtube.com/embed/7kcxl6cz1co",
        //-       :ratio="16 / 9",
        //-       style="border-radius: 1.5em"
        //-     )

        //- q-img(
        //-   v-if="!this.$q.screen.lt.sm",
        //-   :src="getWorkflowImg('land')",
        //-   ref="learnmore"
        //- )
        //- q-img(
        //-   v-if="this.$q.screen.lt.sm",
        //-   :src="getWorkflowImg('vert')",
        //-   ref="learnmore"
        //- )

        //- .q-pa-md
        //-   q-item.q-mt-xl(ref="events")
        //-     q-item-section
        //-       .text-uppercase.text-left.text-weight-bold.text-body1.title {{ $t('inspire') }}
        //-         //- .text-caption {{ $t('upcoming_events') }}

        //- .row.q-col-gutter-lg.items-stretch.no-wrap.scroll(
        //-   :class="{ 'no-wrap': $q.screen.lt.sm, scroll: $q.screen.lt.sm }"
        //- )
        //-   .col-8.col-sm-6.col-md-3.col-lg-4.col-xl-2.q-mr-md.q-ml-lg(
        //-     v-for="(event, index) in eventsordered",
        //-     :key="index"
        //-   )
        //-     q-card.full-height.column(flat, bordered, style="width: 110%")
        //-       q-img.relative(:src="getEventImg(event)", :ratio="1")
        //-       q-card-section.col
        //-         .text-body2.text-bold.text-left {{ $t(`events.${event.tag}.title`) }}
        //-         .text-body2.text-left(v-if="langSelected") {{ $t(`events.${event.tag}.caption`) }}
        //-       q-separator
        //-       q-item.justify-center
        //-         q-btn(
        //-           color="primary",
        //-           unelevated,
        //-           rounded,
        //-           type="a",
        //-           href="https://solferinoacademy.com/limitless-information-session-recordings/",
        //-           target="_blank"
        //-         ) {{ $t('recording_btn') }}
          //- q-list(separator)
          //-   q-select.q-pa-sm(
          //-     dense,
          //-     emit-value,
          //-     map-options,
          //-     borderless,
          //-     v-model="eventslang",
          //-     :options="eventslangsoptions",
          //-     @input="(val) => { onSelectChange(val); }",
          //-     clearable,
          //-     behavior="menu",
          //-     :label="$t('choose_language')"
          //-   )
          //-     template(v-slot:prepend)
          //-       q-icon(:name="matTranslate")
          //-     template(v-slot:no-option)
          //-       q-item
          //-         q-item-section.text-grey {{ $t('all_regions') }}
          //-   q-item(
          //-     v-for="(session, index) in event.sessions",
          //-     v-if="isEventLang(session)",
          //-     :key="index"
          //-   )
          //-     q-item-section
          //-       q-item-label.text-left.text-secondary.text-bold {{ session.at.toFormat('ff (z)') }}
          //-       q-item-label.text-left.text-secondary(caption) {{ session.at.setZone('CET').toFormat('ff (z)') }}
          //-       q-item-label.text-left.text-caption.text-grey-7
          //-         span(v-for="lang in session.langs") {{ codeToLang(lang) }} &middot;
          //-     q-item-section(side, v-if="!pastEvents(session.at)")
          //-       q-btn(
          //-         :disable="!session.url",
          //-         color="primary",
          //-         unelevated,
          //-         rounded,
          //-         type="a",
          //-         :href="session.url",
          //-         target="_blank"
          //-       ) {{ $t('register_btn') }}
          //-     q-item-section(side, v-else)
          //-       q-btn(
          //-         :disable="!session.url",
          //-         color="primary",
          //-         unelevated,
          //-         rounded,
          //-         type="a",
          //-         href="https://solferinoacademy.com/limitless-information-session-recordings/",
          //-         target="_blank"
          //-       ) {{ $t('recording_btn') }}

        .q-pa-md.text-left
          //- q-item.q-mt-xl(ref="apply")
          //-   q-item-section.q-pa-none.text-left
          //-     .text-uppercase.text-left.text-weight-bold.text-body1.title.q-mb-lg {{ $t('communitysupport') }}
          //-     .text-hero {{ $t('upload_draft_problem') }}
          //-     br
          //-     .text-hero {{ $t('findthis') }}

          //- q-btn.q-ma-md(
          //-   @click="startLogin()",
          //-   size="lg",
          //-   rounded,
          //-   outline,
          //-   color="primary"
          //- ) {{ $t('upload_draft') }}

          q-item.q-mt-xl(ref="apply")
            q-item-section.q-pa-none.text-left
              .text-uppercase.text-left.text-weight-bold.title.q-mb-lg {{ $t('innovation_academy') }}

              .text-hero {{ $t('apply_to_join') }}
              ul.text-hero
                li {{ $t('submit_info_title_1') }}
                li {{ $t('phase1_info_title') }}
                //- li {{ $t('phase2_info_title') }}

              .text-hero {{ $t('prioritise_health') }}

          .q-mt-lg.q-ml-lg
            q-btn(size="lg", type="a", href="/live", rounded, color="primary") View Our Academy

          //- q-btn.q-ma-md(
          //-   @click="startLogin()",
          //-   size="lg",
          //-   rounded,
          //-   color="primary"
          //- ) {{ $t('view_profile') }}

        //- Languages
        //- q-banner.bg-secondary.q-pa-md.q-mt-xl.q-pb-xl(square)
        //-   .text-h5.text-white.q-my-lg.text-bold {{ $t('submit_in') }}
        //-   q-chip(
        //-     :size="$q.screen.lt.md ? 'md' : 'xl'",
        //-     color="transparent",
        //-     text-color="white",
        //-     v-for="lang in langs",
        //-     :key="lang.value"
        //-   ) {{ lang.label }}
          //- How to submit

          //- .text-h5.text-white.q-my-xl.text-bold {{ $t('how_to_submit') }}

          //- .row.justify-center.text-bold.text-secondary.text-body1.q-px-md.q-px-md.text-white
          //-   .col-md-2.col-12
          //-     q-icon.rounder(
          //-       :name="matUpload",
          //-       :size="$q.screen.gt.md ? '36px' : '24px'"
          //-     )
          //-     div(:class="{ 'q-mb-md': $q.screen.lt.md }") {{ $t('pipeline1') }}
          //-   .col-auto.dots(v-if="$q.screen.gt.sm")
          //-     q-icon(:name="matMoreHoriz", size="40px")

          //-   .col-md-2.col-12
          //-     q-icon.rounder(
          //-       :name="matPendingActions",
          //-       :size="$q.screen.gt.md ? '36px' : '24px'"
          //-     )
          //-     div(:class="{ 'q-mb-md': $q.screen.lt.md }") {{ $t('pipeline2') }}
          //-   .col-auto.dots(v-if="$q.screen.gt.sm")
          //-     q-icon(:name="matMoreHoriz", size="40px")

          //-   .col-md-2.col-12
          //-     q-icon.rounder(
          //-       :name="matAutoFixHigh",
          //-       :size="$q.screen.gt.md ? '36px' : '24px'"
          //-     )
          //-     div(:class="{ 'q-mb-md': $q.screen.lt.md }") {{ $t('pipeline3') }}
          //-   .col-auto.dots(v-if="$q.screen.gt.sm")
          //-     q-icon(:name="matMoreHoriz", size="40px")

          //-   .col-md-2.col-12
          //-     q-icon.rounder(
          //-       :name="matShare",
          //-       :size="$q.screen.gt.md ? '36px' : '24px'"
          //-     )
          //-     div(:class="{ 'q-mb-md': $q.screen.lt.md }") {{ $t('pipeline4') }}

          //- .row.text-left.justify-center.q-mx-xl.q-mt-lg.text-body1.text-white
          //-   .col-12.col-md-6
          //-     .text-bold.text-uppercase {{ $t('instructions_title') }}
          //-     ul.q-ml-none.q-pl-md
          //-       li(
          //-         v-for="(message, index) in messages.instructions",
          //-         :key="index"
          //-       ) {{ message }}
          //-       li {{ $t('instruction_agree') }}
          //-       a(text-color="white", href="/policy") {{ $t('terms_privacy_policy') }}

        //- q-btn.q-mb-xl.q-mt-md.on-left(
        //-     @click="startLogin()",
        //-     size="lg",
        //-     :icon-right="matUpload",
        //-     rounded,
        //-     color="primary"
        //-   ) {{ $t('start_journey') }}
          //- HIDE DURING PHASE 1:

        .q-pa-md
          q-item.q-mb-md
            q-item-section
              .text-uppercase.text-left.text-weight-bold.text-body1.title {{ $t('highlighted_submissions') }}
            q-item-section(side)
              q-btn(
                flat,
                color="primary",
                :icon-right="matChevronRight",
                type="a",
                href="/live",
                dense
              ) {{ $t('see_more') }}

          //- .row.q-col-gutter-lg.items-stretch.no-wrap.scroll(
          //-   :class="{ 'no-wrap': $q.screen.lt.sm, scroll: $q.screen.lt.sm }"
          //- )
          q-spinner-dots(color="primary", size="2em", v-if="!highlights")

        .row.q-col-gutter-lg.items-stretch.no-wrap.scroll.q-pb-lg.q-mb-md(
          v-if="highlights",
          :class="{ 'no-wrap': $q.screen.lt.sm, scroll: $q.screen.lt.sm }"
        )
          .col-8.col-sm-6.col-md-3.col-lg-4.col-xl-2.q-mr-md.q-ml-lg(
            v-for="(submission, index) in highlights.subDocs",
            :key="index"
          )
            q-card.full-height.column(flat, bordered, style="width: 110%")
              q-video(
                :src="'https://www.youtube.com/embed/' + submission.media.youtube",
                :ratio="16 / 9"
              )
              q-card-section.q-pa-xs.text-right
                q-chip.q-pa-none.on-left(
                  color="transparent",
                  text-color="primary",
                  v-for="tag in submission.tags",
                  :key="tag",
                  :icon="getTagIcon(tag)"
                )
                  q-tooltip {{ $t('tags.' + tag) }}
              q-card-section.q-pa-xs.text-right
                q-chip.q-pl-none.q-pr-none.on-left.flag(
                  rounded,
                  color="transparent",
                  text-color="white"
                )
                  .flag {{ getRegion(submission.region).flag }}
                  q-tooltip {{ getRegion(submission.region).name }}

        //- .q-pa-md
        //-   q-item
        //-     q-item-section
        //-       .text-uppercase.text-left.text-weight-bold.text-body1.title {{ $t('academy_membership') }}
        //-     q-item-section(side)
        //-       q-btn(
        //-         flat,
        //-         color="primary",
        //-         :icon-right="matChevronRight",
        //-         type="a",
        //-         href="/academy",
        //-         dense
        //-       ) {{ $t('see_more') }}

        //- q-spinner-dots(color="primary", size="40px" v-if="!academy")

        //- .row.q-col-gutter-lg(
        //-   v-if="academy",
        //-   :class="{ 'no-wrap': $q.screen.lt.sm, scroll: $q.screen.lt.sm }"
        //- )
        //-   .col-8.col-sm-6.col-md-3.col-lg-4.col-xl-2.q-mr-md.q-ml-lg(
        //-     v-for="(user, index) in academy.userDocs",
        //-     :key="index"
        //-   )
        //-     .profileborder.overflow-hidden
        //-       .row
        //-         .col-auto
        //-           q-avatar.bg-grey-5.on-left(circle, size="100px")
        //-             q-img(:src="user.photo_url", v-if="user.photo_url")
        //-             q-icon(:name="matPerson", v-if="!user.photo_url")
        //-         .col.self-center
        //-           div
        //-             strong.text-body-3 {{ user.user_name }}
        //-           q-btn.q-mt-sm(
        //-             dense,
        //-             v-if="user.profile_url",
        //-             type="a",
        //-             :href="user.profile_url",
        //-             target="_blank",
        //-             unelevated,
        //-             color="blue-9"
        //-           )
        //-             q-icon.on-left(:name="fabLinkedinIn")
        //-             span {{ $t('view_profile') }}
        //-         .col-auto.self-center.on-left
        //-           q-chip.q-pl-none.q-pr-none(
        //-             rounded,
        //-             v-if="user.submissions",
        //-             color="transparent",
        //-             text-color="white"
        //-           )
        //-             .flag {{ getSubRegion(user).flag }}
        //-             q-tooltip {{ getSubRegion(user).name }}
          //- END HIDE



        //- q-item.q-my-xl(ref="events")
        //-   q-item-section
        //-     .text-uppercase.text-left.text-weight-bold.text-body1.title {{ $t('upcoming_events') }}

        //- .row.q-col-gutter-lg.items-stretch.no-wrap.scroll(
        //-   :class="{ 'no-wrap': $q.screen.lt.sm, scroll: $q.screen.lt.sm }"
        //- )
        //-   .col-10.col-sm-6.col-md-4.col-lg-3.col-xl-2.q-mr-lg(
        //-     v-for="(event, index) in eventssingle",
        //-     :key="index"
        //-   )
        //-     q-card.full-height.column(flat, bordered style="width:110%")
        //-       q-img.relative(:src="getEventImg(event)", :ratio="1")
        //-       q-card-section.col
        //-         //- .text-body2.text-bold.text-left {{ $t(`events.e${index}.title`) }}
        //-         //- .text-body2.text-left {{ $t(`events.e${index}.caption`) }}
        //-         .text-body2.text-bold.text-left {{ $t(`events.${event.tag}.title`) }}
        //-         .text-body2.text-left {{ $t(`events.${event.tag}.caption`) }}
        //-       q-separator
        //-       q-list(separator)
        //-         q-item(
        //-           :key="index"
        //-         )
        //-           q-item-section
        //-             q-item-label.text-left.text-secondary.text-bold {{ event.at.toFormat('ff (z)') }}
        //-             q-item-label.text-left.text-secondary(caption) {{ event.at.setZone('CET').toFormat('ff (z)') }}
        //-             q-item-label.text-left.text-caption.text-grey-7
        //-               span(v-for="lang in event.langs") {{ codeToLang(lang) }} &middot;
        //-           q-item-section(side)
        //-             q-btn(
        //-               :disable="!event.url",
        //-               color="primary",
        //-               unelevated,
        //-               rounded,
        //-               type="a",
        //-               :href="event.url",
        //-               target="_blank"
        //-             ) {{ $t('register_btn') }}

        //- .q-pa-md
        //-   q-item.q-my-xl
        //-     q-item-section
        //-       .text-uppercase.text-left.text-weight-bold.text-body1.title {{ $t('innovation_stories') }}
        //-     q-item-section(side)
        //-       q-btn(
        //-         flat,
        //-         color="primary",
        //-         :icon-right="matChevronRight",
        //-         type="a",
        //-         href="https://www.youtube.com/channel/UCSs4Z5g6Mj-QNFtsQPsgtWA",
        //-         dense
        //-       ) {{ $t('see_more') }}

        //- .row.q-col-gutter-lg.q-pl-lg(
        //-   :class="{ 'no-wrap': $q.screen.lt.sm, scroll: $q.screen.lt.sm }"
        //- )
        //-   .col-10.col-sm-6.col-md-4.col-xl-3(
        //-     v-for="(story, index) in stories",
        //-     :key="index"
        //-   )
        //-     q-card(flat, bordered)
        //-       //- q-img(:src="story.url", :ratio="16 / 9")
        //-       q-video(:src="story.src", :ratio="16 / 9")
        //-       q-card-section
        //-         .text-body2.text-bold.text-left {{ $t(`stories.s${index}.title`) }}
        //-         //- .text-body2.text-left {{ $t(`stories.s${index}.caption`)}}
        //- .q-pa-md
        //-   q-item.q-mt-xl
        //-     q-item-section
        //-       .text-uppercase.text-left.text-weight-bold.text-body1.title {{ $t('faq_title') }}

        //-   q-list(separator)
        //-     q-item(v-for="faq of messages.faq", :key="faq.question")
        //-       q-item-section.text-left.q-mb-lg
        //-         .text-h5.text-secondary.q-mt-md {{ faq.question }}
        //-         .text-body1.text-grey-8 {{ faq.answer }}

  //- div(style="height: 130px")
  //- Countdown.fixed-bottom(v-on:submit="startLogin")

  q-footer.bg-white.text-primary.text-center.q-py-lg.z-top.q-px-lg(
    style="margin-bottom: 20px"
  )
    .text-weight-bold.text-body1.title.q-mb-lg {{ $t('terms_privacy_policy') }}
    .text-black {{ $t('oss') }}

    a(
      target="_blank",
      href="https://gitlab.com/action-lab-aus/youth-innovation"
    ) {{ $t('view_code') }}
    div &middot;
    .text-black {{ $t('othercontent') }}

    a(text-color="white", href="/policy") {{ $t('terms_privacy_policy') }}
    span &middot;
    a(
      href="https://solferinoacademy.com/community-guidelines/",
      target="_blank"
    ) {{ $t('community_guidelines') }}
    span &middot;
    a(
      href="https://solferinoacademy.com/event-privacy-policy/",
      target="_blank"
    ) {{ $t('event_privacy_policy') }}

    .text-weight-bold.text-body1.title.q-my-lg {{ $t('translation_credit_title') }}

    q-spinner-dots(size="2em", color="primary", v-if="!stats || !stats.admin")
    div(v-if="stats && stats.admin")
      //- .text-bold.q-my-sm Translation, Transcription and Moderation
      q-chip(v-for="(person, index) in stats.admin", :key="index")
        q-avatar(round)
          q-img(:src="person.photoURL")
        div {{ person.displayName }}

    .text-weight-bold.text-body1.title.q-mt-lg {{ $t('supporters') }}
    img.q-mt-lg(
      src="@/assets/img/logos.png",
      width="100%",
      style="max-width: 1000px"
    )
</template>

<script>
import { mapActions, mapState, mapGetters } from "vuex";
import Countdown from "@/components/Countdown";
import { auth } from "../db";
import reduce from "lodash/reduce";
import includes from "lodash/includes";
import find from "lodash/find";
import sortBy from "lodash/sortBy";
import Language from "@/mixins/Language";
import { DateTime } from "luxon";
const regions = require("@/ifrclist.json");
import {
  signInWithEmailLink,
  isSignInWithEmailLink,
  sendSignInLinkToEmail,
} from "firebase/auth";

import { scroll } from "quasar";
import langs from "../langs";
const { getScrollTarget, setScrollPosition } = scroll;

/* eslint-disable no-control-regex */
const emailreg =
  /(?:[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*|"(?:[\x01-\x08\x0b\x0c\x0e-\x1f\x21\x23-\x5b\x5d-\x7f]|\\[\x01-\x09\x0b\x0c\x0e-\x7f])*")@(?:(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?|\[(?:(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(?:25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?|[a-z0-9-]*[a-z0-9]:(?:[\x01-\x08\x0b\x0c\x0e-\x1f\x21-\x5a\x53-\x7f]|\\[\x01-\x09\x0b\x0c\x0e-\x7f])+)\])/;

export default {
  props: ["logo"],
  mixins: [Language],
  components: {
    Countdown,
  },
  data() {
    return {
      logoswitch: true,
      eventslang: null,
      accessToken: null,
      email: "",
      emailLogin: false,
      mainLogin: false,
      sentEmail: false,
      loading: true,
      countDown: undefined,
      event: 1,
      story: 1,
      langSelected: false,
      workflowimages: [
        "ar",
        "bn",
        "en",
        "es",
        "fa",
        "fr",
        "hi",
        "id",
        "ja",
        "ko",
        "pa",
        "pt",
        "ru",
        "sw",
        "tr",
        "ur",
        "zh",
      ],
      eventslangsoptions: [
        { value: "en", label: this.codeToLang("en") },
        { value: "ar", label: this.codeToLang("ar") },
        { value: "fr", label: this.codeToLang("fr") },
        { value: "es", label: this.codeToLang("es") },
      ],
      stories: [
        {
          src: "https://www.youtube.com/embed/Nmv-jtDForg",
        },
        {
          src: "https://www.youtube.com/embed/8DJhfPfHNT8",
        },
        {
          src: "https://www.youtube.com/embed/OK-w6AXE4Wk",
        },
        {
          src: "https://www.youtube.com/embed/W8JVMHdH0CA",
        },
      ],
    };
  },
  computed: {
    events() {
      return [
        {
          tag: "ecuador",
          src: "ecuador.png",
          imgs: [
            "ar",
            "bn",
            "en",
            "es",
            "fa",
            "fr",
            "hi",
            "id",
            "ja",
            "ko",
            "pa",
            "pt",
            "ru",
            "sw",
            "tr",
            "ur",
            "zh",
          ],
          sessions: [
            {
              at: DateTime.fromFormat(
                "16:00 10/06/2021 +2",
                "hh:mm dd/MM/yyyy Z"
              ),
              langs: ["en", "ar", "fr"],
              url: "https://zoom.us/meeting/register/tJYqcOCrqD8pGNGeHwxxsqXpHI-SQVVbhFtc",
            },
            {
              at: DateTime.fromFormat(
                "18:00 15/06/2021 +2",
                "hh:mm dd/MM/yyyy Z"
              ),
              langs: ["es", "en"],
              url: "https://zoom.us/meeting/register/tJYvcOCupz8iGd1KrLDEGyLoist53iNN2HGc",
            },
          ],
        },
        {
          src: "danish.png",
          tag: "danish",
          imgs: [
            "ar",
            "bn",
            "en",
            "es",
            "fa",
            "fr",
            "hi",
            "id",
            "ja",
            "ko",
            "pa",
            "pt",
            "ru",
            "sw",
            "tr",
            "ur",
            "zh",
          ],
          sessions: [
            {
              at: DateTime.fromFormat(
                "10:00 14/06/2021 +2",
                "hh:mm dd/MM/yyyy Z"
              ),
              langs: ["en", "ar", "fr"],
              url: "https://zoom.us/meeting/register/tJclf-6uqDwiHNeUocXLT7H1nAIGa-f3Apt_",
            },
            {
              at: DateTime.fromFormat(
                "15:00 14/06/2021 +2",
                "hh:mm dd/MM/yyyy Z"
              ),
              langs: ["en", "es"],
              url: "https://zoom.us/meeting/register/tJItcuCtpjgtGdI9FNHZRVoxa-nHRpiKAxMK",
            },
          ],
        },
        {
          src: "uk.png",
          tag: "uk",
          imgs: [
            "ar",
            "bn",
            "en",
            "es",
            "fa",
            "fr",
            "hi",
            "id",
            "ja",
            "ko",
            "pa",
            "pt",
            "ru",
            "sw",
            "tr",
            "ur",
            "zh",
          ],
          sessions: [
            {
              at: DateTime.fromFormat(
                "11:00 25/06/2021 +2",
                "hh:mm dd/MM/yyyy Z"
              ),
              langs: ["en", "ar", "fr"],
              url: "https://zoom.us/meeting/register/tJAlce6qqj8qGNUa5nNhofd5_mjFDbJQ5sqH",
            },
            {
              at: DateTime.fromFormat(
                "15:00 25/06/2021 +2",
                "hh:mm dd/MM/yyyy Z"
              ),
              langs: ["en", "es"],
              url: "https://zoom.us/meeting/register/tJAsf-2trTMtH9DK-9iDeoMVRJQdMvUFLhcl",
            },
          ],
        },
        {
          imgs: [
            "ar",
            "bn",
            "en",
            "es",
            "fa",
            "fr",
            "hi",
            "id",
            "ja",
            "ko",
            "pa",
            "pt",
            "ru",
            "sw",
            "tr",
            "ur",
            "zh",
          ],
          src: "submission.png",
          tag: "submission",
          sessions: [
            {
              at: DateTime.fromFormat(
                "09:30 09/06/2021 +2",
                "hh:mm dd/MM/yyyy Z"
              ),
              langs: ["en"],
              url: "https://zoom.us/meeting/register/tJIkc-mtqj4sH9M2WjargqVnAshl5iONYZe1",
            },
            {
              at: DateTime.fromFormat(
                "15:00 07/07/2021 +2",
                "hh:mm dd/MM/yyyy Z"
              ),
              langs: ["en"],
              url: "https://zoom.us/meeting/register/tJ0tf-6gpz0oGNEB1baGh15bRpBCykAS7TPy",
            },
            {
              at: DateTime.fromFormat(
                "17:00 09/06/2021 +2",
                "hh:mm dd/MM/yyyy Z"
              ),
              langs: ["es"],
              url: "https://zoom.us/meeting/register/tJEsd-qgrT8iG9xW7iFh-FY7FNhlTjqYhKoi",
            },
            {
              at: DateTime.fromFormat(
                "11:00 16/06/2021 +2",
                "hh:mm dd/MM/yyyy Z"
              ),
              langs: ["ar"],
              url: "https://zoom.us/meeting/register/tJUucOGqrjMtG9Pq-d8F018e17N7lXp4mnBA",
            },
            {
              at: DateTime.fromFormat(
                "09:30 16/06/2021 +2",
                "hh:mm dd/MM/yyyy Z"
              ),
              langs: ["fr"],
              url: "https://zoom.us/meeting/register/tJMkdOugrDspHNTvl9WPmjqEzakp_Gzu0O_8",
            },
          ],
        },
        {
          src: "kenyan.png",
          tag: "kenyan",
          imgs: [
            "ar",
            "bn",
            "en",
            "es",
            "fa",
            "fr",
            "hi",
            "id",
            "ja",
            "ko",
            "pa",
            "pt",
            "ru",
            "sw",
            "tr",
            "ur",
            "zh",
          ],
          sessions: [
            {
              at: DateTime.fromFormat(
                "09:00 14/07/2021 +2",
                "hh:mm dd/MM/yyyy Z"
              ),
              langs: ["en", "ar", "fr"],
              url: "https://zoom.us/meeting/register/tJwudO6gpzIqEtG6oRk-6gxAqJa2ABUDPMeB",
            },
            {
              at: DateTime.fromFormat(
                "15:00 14/07/2021 +2",
                "hh:mm dd/MM/yyyy Z"
              ),
              langs: ["en", "es"],
              url: "https://zoom.us/meeting/register/tJcsduCorDsoGdX7sM91lGC19MYipZbEtjWS",
            },
          ],
        },
        {
          src: "netherlands.png",
          tag: "netherlands",
          imgs: [
            "ar",
            "bn",
            "en",
            "es",
            "fa",
            "fr",
            "hi",
            "id",
            "ja",
            "ko",
            "pa",
            "pt",
            "ru",
            "sw",
            "tr",
            "ur",
            "zh",
          ],
          sessions: [
            {
              at: DateTime.fromFormat(
                "10:00 24/06/2021 +2",
                "hh:mm dd/MM/yyyy Z"
              ),
              langs: ["en", "ar", "fr"],
              url: "https://zoom.us/meeting/register/tJ0od--hrjstHtc2qjySTpSOnZD-n4tT-lUO",
            },
            {
              at: DateTime.fromFormat(
                "15:00 24/06/2021 +2",
                "hh:mm dd/MM/yyyy Z"
              ),
              langs: ["es", "en"],
              url: "https://zoom.us/meeting/register/tJUucOuprzooHNxozCPcEIKi3QH3k5ET7q08",
            },
          ],
        },
        {
          src: "australia.png",
          tag: "australia",
          imgs: [
            "ar",
            "bn",
            "en",
            "es",
            "fa",
            "fr",
            "hi",
            "id",
            "ja",
            "ko",
            "pa",
            "pt",
            "ru",
            "sw",
            "tr",
            "ur",
            "zh",
          ],
          sessions: [
            {
              at: DateTime.fromFormat(
                "08:00 01/07/2021 +2",
                "hh:mm dd/MM/yyyy Z"
              ),
              langs: ["en", "ar", "fr"],
              url: "https://zoom.us/meeting/register/tJYode6urjotE9H-lqnI2GfLXTQXRPcpXTZX",
            },
            {
              at: DateTime.fromFormat(
                "10:30 06/07/2021 +2",
                "hh:mm dd/MM/yyyy Z"
              ),
              langs: ["en", "es"],
              url: "https://zoom.us/meeting/register/tJ0rfu-vrDsjGtfDaDO3nN7ureyJAqa7XmJi",
            },
          ],
        },
        {
          src: "german.png",
          tag: "german",
          imgs: [
            "ar",
            "bn",
            "en",
            "es",
            "fa",
            "fr",
            "hi",
            "id",
            "ja",
            "ko",
            "pa",
            "pt",
            "ru",
            "sw",
            "tr",
            "ur",
            "zh",
          ],
          sessions: [
            {
              at: DateTime.fromFormat(
                "09:30 29/06/2021 +2",
                "hh:mm dd/MM/yyyy Z"
              ),
              langs: ["en", "ar", "fr"],
              url: "https://zoom.us/meeting/register/tJElfu2orDwrGNCP0Ntm9hxFj1_GQhbnXYfT",
            },
            {
              at: DateTime.fromFormat(
                "15:30 29/06/2021 +2",
                "hh:mm dd/MM/yyyy Z"
              ),
              langs: ["en", "es"],
              url: "https://zoom.us/meeting/register/tJUlde2qrT8pHd1xUyKmkBA2CQHfYagdCJ0Q",
            },
          ],
        },
        {
          src: "aj1.png",
          tag: "aj1",
          imgs: ["en", "ar", "fr", "es"],
          sessions: [
            {
              at: DateTime.fromFormat(
                "11:00 30/06/2021 +2",
                "hh:mm dd/MM/yyyy Z"
              ),
              langs: ["en"],
              url: "https://ajmn-digital.zoom.us/j/2121211200",
            },
            {
              at: DateTime.fromFormat(
                "09:00 27/06/2021 +2",
                "hh:mm dd/MM/yyyy Z"
              ),
              langs: ["ar"],
              url: "https://zoom.us/j/98035869667?pwd=YXJhN3VGd2o2SURlNGFaYTFzOWpBdz09",
            },
            {
              at: DateTime.fromFormat(
                "13:00 30/06/2021 +2",
                "hh:mm dd/MM/yyyy Z"
              ),
              langs: ["fr"],
              url: "https://zoom.us/j/95206013855?pwd=MW5IUm5hNXB5b1hIcWM1SGNDS1BCUT09",
            },
            {
              at: DateTime.fromFormat(
                "17:00 21/06/2021 +2",
                "hh:mm dd/MM/yyyy Z"
              ),
              langs: ["es"],
              url: "https://ajmn-digital.zoom.us/j/94637236355",
            },
          ],
        },
        {
          tag: "510",
          src: "510.png",
          imgs: ["ar", "en", "es", "fr"],
          sessions: [
            {
              at: DateTime.fromFormat(
                "11:00 13/07/2021 +2",
                "hh:mm dd/MM/yyyy Z"
              ),
              langs: ["en", "ar", "fr"],
              url: "https://us06web.zoom.us/meeting/register/tZ0pcuyqpjsqE9eBfQ2mV_4KBUtTdmG0wEhC",
            },
          ],
        },
      ];
    },
    keydates() {
      return [
        {
          dates: [
            DateTime.fromFormat("06", "MM").toFormat("MMMM"),
            DateTime.fromFormat("07", "MM").toFormat("MMMM"),
          ],
          title: this.$t("join_events"),
        },
        {
          dates: [
            DateTime.fromFormat("01/06/2021", "dd/MM/yyyy").toFormat("d MMMM"),
            DateTime.fromFormat("18/06/2021", "dd/MM/yyyy").toFormat("d MMMM"),
          ],
          title: this.$t("upload_draft"),
          subtitle: this.$t("phaseList.phase_1"),
        },
        {
          dates: [
            DateTime.fromFormat("19/06/2021", "dd/MM/yyyy").toFormat("d MMMM"),
            DateTime.fromFormat("26/06/2021", "dd/MM/yyyy").toFormat("d MMMM"),
          ],
          title: this.$t("upload_draft"),
          subtitle: this.$t("phaseList.phase_2"),
        },
        {
          dates: [
            DateTime.fromFormat("28/06/2021", "dd/MM/yyyy").toFormat("d MMMM"),
            DateTime.fromFormat("16/07/2021", "dd/MM/yyyy").toFormat("d MMMM"),
          ],
          title: this.$t("submit_to", [this.$t("phaseList.phase_submit")]),
        },
      ];
    },
    ...mapGetters(["getTagIcon"]),
    ...mapState(["stats", "highlights", "academy", "user"]),
    eventsordered() {
      return sortBy(this.events, function (e) {
        if (e.sessions[0]) return e.sessions[0].at || 10000000000000000;
        else return 1000000000000000000;
      });
    },
    numbers() {
      if (!this.stats) return 0;
      return reduce(
        this.stats.submissionStats,
        function (sum, n) {
          return sum + n;
        },
        0
      );
    },
    messages() {
      return this.$i18n.messages[this.$i18n.locale];
    },
    langs() {
      let lngs = [];
      for (let l of langs)
        lngs.push({
          label: this.codeToLang(l),
          value: l,
        });
      return lngs;
    },
  },
  watch: {
    loading: {
      immediate: true,
      handler(val) {
        if (val) {
          this.$q.loading.show({
            delay: 400, // ms
          });
        } else {
          this.$q.loading.hide();
        }
      },
    },
  },
  async mounted() {
    const token = this.$route.params.token;
    if (token) {
      await this.signInAction({ token: token });
      this.$router.replace("/submission");
    }

    if (isSignInWithEmailLink(auth, window.location.href)) {
      let email = window.localStorage.getItem("emailForSignIn");
      // console.log(email);
      if (email)
        signInWithEmailLink(auth, email, window.location.href)
          .then(() => {
            // Clear email from local storage
            window.localStorage.removeItem("emailForSignIn");
            return this.$router.replace("/submission");
          })
          .catch((error) => {
            // Clear email from local storage
            window.localStorage.removeItem("emailForSignIn");
            this.$q.notify({
              position: "top-right",
              color: "secondary",
              textColor: "white",
              icon: this.matWarning,
              message: this.$t("link_expired"),
            });
            console.error(error);
          });
      else
        this.$q.notify({
          position: "top-right",
          color: "secondary",
          textColor: "white",
          icon: this.matWarning,
          message: this.$t("link_expired"),
        });
    }

    this.loading = false;

    // Get contributors

    // TODO: replace when in Phase 2
    await Promise.all([this.initConfig()]);

    this.getHighlights();
    // this.getAcademy();
    this.getStats();
  },
  methods: {
    onSelectChange(val) {
      if (val) this.langSelected = true;
      else this.langSelected = false;
    },
    noLangs(sessions) {
      let islang = false;
      sessions.forEach((element) => {
        if (element.langs.includes(this.eventslang)) islang = true;
      });
      return islang;
    },
    pastEvents(sessionAt) {
      return sessionAt <= DateTime.now();
    },
    isEventLang(session) {
      return session.langs.includes(this.eventslang);
    },
    getEventImg(event) {
      let ln = "en";
      // console.log(find(this.eventlangs, this.$i18n.locale));
      if (event.imgs.includes(this.$i18n.locale)) ln = this.$i18n.locale;
      return `/img/events/${ln}/${event.src}`;
    },
    getWorkflowImg(layout) {
      // console.log(this.$i18n.locale);
      let lang = this.$i18n.locale;
      if (!includes(this.workflowimages, this.$i18n.locale)) lang = "en";
      // console.log(`/img/workflows/${layout}/${lang}.png`);
      return `/img/workflows/${layout}/${lang}.png`;
    },
    startLogin() {
      if (this.user) this.$router.push("/submission");
      else this.mainLogin = true;
    },
    getSubRegion(user) {
      if (user.submissions.length)
        return this.getRegion(user.submissions[0].region);
      else return "";
    },
    getRegion(code) {
      return find(regions, { code: code });
    },

    goto(ref) {
      const el = this.$refs[ref].$el;
      const target = getScrollTarget(el);
      const offset = el.offsetTop;
      const duration = 400;
      setScrollPosition(target, offset, duration);
    },
    onIntersection(entry) {
      // console.log(entry);
      this.logo.display = !entry.isIntersecting;
    },
    isEmail(val) {
      return emailreg.test(val);
    },
    isDisabled() {
      if (!this.$refs.emailinput) return true;
      // console.log(this.$refs.emailinput.hasError);
      return this.$refs.emailinput.hasError;
    },
    ...mapActions([
      "signInAction",
      "googleSignInAction",
      "getStats",
      "getHighlights",
      "getAcademy",
      "initConfig",
    ]),

    signInWithLinkedIn() {
      window.location.href = `${process.env.VUE_APP_FUNCTION_URL}/redirect`;
    },
    async signInWithEmail() {
      // console.log(window.location.hostname);
      const actionCodeSettings = {
        url:
          window.location.hostname === "localhost"
            ? "http://localhost:8080/"
            : process.env.VUE_APP_WEB_APP,
        handleCodeInApp: true,
      };

      auth.languageCode =
        window.navigator.userLanguage || window.navigator.language;

      sendSignInLinkToEmail(auth, this.email, actionCodeSettings)
        .then(() => {
          // The link was successfully sent. Inform the user.
          // Save the email locally so you don't need to ask the user for it again
          // if they open the link on the same device.
          window.localStorage.setItem("emailForSignIn", this.email);
        })
        .catch((error) => {
          const errorCode = error.code;
          const errorMessage = error.message;
          console.error(`${errorCode}: ${errorMessage}`);
        });
    },
  },
};
</script>

<style scoped lang="scss">
@media only screen and (min-width: 600px) {
  .text-hero {
    font-size: 1.5em;
  }

  .text-title {
    font-weight: 400;
    font-size: 3.4em;
  }
}

@media only screen and (max-width: 600px) {
  .text-hero {
    font-size: 1.2em;
  }

  .text-title {
    font-weight: 400;
    font-size: 2.4em;
  }
}

.background1 {
  z-index: -10;
  position: relative;
  /* margin-left: 2em; */
  margin-bottom: -2em;
  width: 90%;
  /* transform: scaleX(-100%); */
}

.background2 {
  /* transform: scaleX(-100%); */
  /* margin-right: -20%; */
  width: 140%;
  margin-left: -10%;
}

a:link {
  color: #f2c037;
  background-color: transparent;
  text-decoration: none;
}

a:visited {
  color: #bf3030;
  background-color: transparent;
  text-decoration: none;
}

a:hover {
  color: pink;
  background-color: transparent;
  text-decoration: underline;
}

.mainlogo {
  width: 70%;
}

.register {
  bottom: 1em;
  transform: translateX(-50%);
}

.liblue {
  background: #0a66c2;
  color: white;
}

.title {
  font-size: 1.8em;
  .text-caption {
    font-size: 0.6em;
  }
}

.rounder {
  position: relative;
  border: 1px solid white;
  max-width: 75px;
  max-height: 75px;
  border-radius: 50%;
  padding: 15px;
  margin-bottom: 0.5em;
}

.dots {
  margin-top: 15px;
}
</style>

<style src="@platyplus/humanitarian-icons/dist/icons.css">
/* global styles */
</style>
